# CfnDomainName

The `AWS::ApiGateway::DomainName` resource specifies a public custom domain name for your API in API Gateway.

To create a custom domain name for private APIs, use [AWS::ApiGateway::DomainNameV2](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-apigateway-domainnamev2.html) .

You can use a custom domain name to provide a URL that's more intuitive and easier to recall. For more information about using custom domain names, see [Set up Custom Domain Name for an API in API Gateway](https://docs.aws.amazon.com/apigateway/latest/developerguide/how-to-custom-domains.html) in the *API Gateway Developer Guide* .

Extends: [Construct](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Construct.html) › [CfnElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnElement.html) › [CfnRefElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnRefElement.html) › [CfnResource](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnResource.html) › CfnDomainName
Implements: [IInspectable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IInspectable.html), [ITaggable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ITaggable.html), [IEnvironmentAware](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.IEnvironmentAware.html), [IDomainNameRef](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_apigateway.IDomainNameRef.html), IConstruct, IDependable

- CloudFormation: [`AWS::ApiGateway::DomainName`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-apigateway-domainname.html)
- Source: Generated at build time
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

TypeScript:

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_apigateway as apigateway } from 'aws-cdk-lib';
const cfnDomainName = new apigateway.CfnDomainName(this, 'MyCfnDomainName', /* all optional props */ {
  certificateArn: 'certificateArn',
  domainName: 'domainName',
  endpointAccessMode: 'endpointAccessMode',
  endpointConfiguration: {
    ipAddressType: 'ipAddressType',
    types: ['types'],
  },
  mutualTlsAuthentication: {
    truststoreUri: 'truststoreUri',
    truststoreVersion: 'truststoreVersion',
  },
  ownershipVerificationCertificateArn: 'ownershipVerificationCertificateArn',
  regionalCertificateArn: 'regionalCertificateArn',
  routingMode: 'routingMode',
  securityPolicy: 'securityPolicy',
  tags: [{
    key: 'key',
    value: 'value',
  }],
});
```

Python:

```python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_apigateway as apigateway

cfn_domain_name = apigateway.CfnDomainName(self, "MyCfnDomainName",
    certificate_arn="certificateArn",
    domain_name="domainName",
    endpoint_access_mode="endpointAccessMode",
    endpoint_configuration=apigateway.CfnDomainName.EndpointConfigurationProperty(
        ip_address_type="ipAddressType",
        types=["types"]
    ),
    mutual_tls_authentication=apigateway.CfnDomainName.MutualTlsAuthenticationProperty(
        truststore_uri="truststoreUri",
        truststore_version="truststoreVersion"
    ),
    ownership_verification_certificate_arn="ownershipVerificationCertificateArn",
    regional_certificate_arn="regionalCertificateArn",
    routing_mode="routingMode",
    security_policy="securityPolicy",
    tags=[CfnTag(
        key="key",
        value="value"
    )]
)
```

Java:

```java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.apigateway.*;

CfnDomainName cfnDomainName = CfnDomainName.Builder.create(this, "MyCfnDomainName")
        .certificateArn("certificateArn")
        .domainName("domainName")
        .endpointAccessMode("endpointAccessMode")
        .endpointConfiguration(EndpointConfigurationProperty.builder()
                .ipAddressType("ipAddressType")
                .types(List.of("types"))
                .build())
        .mutualTlsAuthentication(MutualTlsAuthenticationProperty.builder()
                .truststoreUri("truststoreUri")
                .truststoreVersion("truststoreVersion")
                .build())
        .ownershipVerificationCertificateArn("ownershipVerificationCertificateArn")
        .regionalCertificateArn("regionalCertificateArn")
        .routingMode("routingMode")
        .securityPolicy("securityPolicy")
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .build();
```

C# / .NET:

```csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.APIGateway;

var cfnDomainName = new CfnDomainName(this, "MyCfnDomainName", new CfnDomainNameProps {
    CertificateArn = "certificateArn",
    DomainName = "domainName",
    EndpointAccessMode = "endpointAccessMode",
    EndpointConfiguration = new EndpointConfigurationProperty {
        IpAddressType = "ipAddressType",
        Types = new [] { "types" }
    },
    MutualTlsAuthentication = new MutualTlsAuthenticationProperty {
        TruststoreUri = "truststoreUri",
        TruststoreVersion = "truststoreVersion"
    },
    OwnershipVerificationCertificateArn = "ownershipVerificationCertificateArn",
    RegionalCertificateArn = "regionalCertificateArn",
    RoutingMode = "routingMode",
    SecurityPolicy = "securityPolicy",
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } }
});
```

Golang:

```go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnDomainName := awscdk.Aws_apigateway.NewCfnDomainName(this, jsii.String("MyCfnDomainName"), &CfnDomainNameProps{
	CertificateArn: jsii.String("certificateArn"),
	DomainName: jsii.String("domainName"),
	EndpointAccessMode: jsii.String("endpointAccessMode"),
	EndpointConfiguration: &EndpointConfigurationProperty{
		IpAddressType: jsii.String("ipAddressType"),
		Types: []*string{
			jsii.String("types"),
		},
	},
	MutualTlsAuthentication: &MutualTlsAuthenticationProperty{
		TruststoreUri: jsii.String("truststoreUri"),
		TruststoreVersion: jsii.String("truststoreVersion"),
	},
	OwnershipVerificationCertificateArn: jsii.String("ownershipVerificationCertificateArn"),
	RegionalCertificateArn: jsii.String("regionalCertificateArn"),
	RoutingMode: jsii.String("routingMode"),
	SecurityPolicy: jsii.String("securityPolicy"),
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
})
```

## Initializer

TypeScript:

```ts
new CfnDomainName(scope: Construct, id: string, props?: CfnDomainNameProps)
```

Python:

```python
CfnDomainName(scope: Construct, id: str, props: typing.Optional[CfnDomainNameProps] = None)
```

Java:

```java
new CfnDomainName(Construct scope, String id, CfnDomainNameProps props)
```

C# / .NET:

```csharp
new CfnDomainName(Construct scope, string id, CfnDomainNameProps? props = null)
```

Golang:

```go
NewCfnDomainName(Scope Construct, Id *string, Props CfnDomainNameProps)
```

## Construct Props

- `certificateArn`: string — The reference to an AWS -managed certificate that will be used by edge-optimized endpoint or private endpoint for this domain name.

  Certificate Manager is the only supported source.

- `domainName`: string — The custom domain name as an API host name, for example, `my-api.example.com` .

- `endpointAccessMode`: string — The endpoint access mode for your DomainName.

- `endpointConfiguration`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDomainName.EndpointConfigurationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_apigateway.CfnDomainName.EndpointConfigurationProperty.html) — The endpoint configuration of this DomainName showing the endpoint types and IP address types of the domain name.

- `mutualTlsAuthentication`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDomainName.MutualTlsAuthenticationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_apigateway.CfnDomainName.MutualTlsAuthenticationProperty.html) — The mutual TLS authentication configuration for a custom domain name.

  If specified, API Gateway performs two-way authentication between the client and the server. Clients must present a trusted certificate to access your API.

- `ownershipVerificationCertificateArn`: string — The ARN of the public certificate issued by ACM to validate ownership of your custom domain.

  Only required when configuring mutual TLS and using an ACM imported or private CA certificate ARN as the RegionalCertificateArn.

- `regionalCertificateArn`: string — The reference to an AWS -managed certificate that will be used for validating the regional domain name.

  Certificate Manager is the only supported source.

- `routingMode`: string = "BASE_PATH_MAPPING_ONLY" — The routing mode for this domain name.

  The routing mode determines how API Gateway sends traffic from your custom domain name to your public APIs.

- `securityPolicy`: string — The Transport Layer Security (TLS) version + cipher suite for this DomainName.

- `tags`: [CfnTag](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — The collection of tags.

  Each tag element is associated with a given resource.

## Properties

- `attrDistributionDomainName`: string — The Amazon CloudFront distribution domain name that's mapped to the custom domain name.

  This is only applicable for endpoints whose type is `EDGE` .

  Example: `d111111abcdef8.cloudfront.net`

- `attrDistributionHostedZoneId`: string — The region-agnostic Amazon Route 53 Hosted Zone ID of the edge-optimized endpoint.

  The only valid value is `Z2FDTNDATAQYW2` for all regions.

- `attrDomainNameArn`: string — The ARN of the domain name.

- `attrRegionalDomainName`: string — The domain name associated with the regional endpoint for this custom domain name.

  You set up this association by adding a DNS record that points the custom domain name to this regional domain name.

- `attrRegionalHostedZoneId`: string — The region-specific Amazon Route 53 Hosted Zone ID of the regional endpoint.

- `certificateArn`: string — The reference to an AWS -managed certificate that will be used by edge-optimized endpoint or private endpoint for this domain name.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `domainName`: string — The custom domain name as an API host name, for example, `my-api.example.com` .

- `domainNameRef`: [DomainNameReference](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_apigateway.DomainNameReference.html) — A reference to a DomainName resource.

- `endpointAccessMode`: string — The endpoint access mode for your DomainName.

- `endpointConfiguration`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDomainName.EndpointConfigurationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_apigateway.CfnDomainName.EndpointConfigurationProperty.html) — The endpoint configuration of this DomainName showing the endpoint types and IP address types of the domain name.

- `env`: [ResourceEnvironment](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `mutualTlsAuthentication`: [IResolvable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDomainName.MutualTlsAuthenticationProperty](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_apigateway.CfnDomainName.MutualTlsAuthenticationProperty.html) — The mutual TLS authentication configuration for a custom domain name.

- `node`: [Node](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ownershipVerificationCertificateArn`: string — The ARN of the public certificate issued by ACM to validate ownership of your custom domain.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `regionalCertificateArn`: string — The reference to an AWS -managed certificate that will be used for validating the regional domain name.

- `routingMode`: string — The routing mode for this domain name.

- `securityPolicy`: string — The Transport Layer Security (TLS) version + cipher suite for this DomainName.

- `stack`: [Stack](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — The collection of tags.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForDomainName(resource: IDomainNameRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromDomainName(scope: Construct, id: string, domainName: string): IDomainNameRef` (static) — Creates a new IDomainNameRef from a domainName.

- `fromDomainNameArn(scope: Construct, id: string, arn: string): IDomainNameRef` (static) — Creates a new IDomainNameRef from an ARN.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnDomainName(x: any): boolean` (static) — Checks whether the given object is a CfnDomainName.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
